/* udm_header.h */

#include <stdio.h>

char * GetToken(char *s, const char *delim, char **last) {

    const char *spanp;
    int c, sc;
    char *tok;

    if (s == NULL && (s = *last) == NULL)
	    return NULL;

cont:
    c = *s++;
    for (spanp = delim; (sc = *spanp++) != 0; )
    {
	    if (c == sc)
		{
	        goto cont;
	    }
    }

    if (c == 0)  /* no non-delimiter characters */
    {
	    *last = NULL;
	    return NULL;
    }
    tok = s - 1;

    for (;;)
    {
	    c = *s++;
	    spanp = delim;
	    do
	    {
	        if ((sc = *spanp++) == c)
	        {
		        if (c == 0)
		        {
		            s = NULL;
		        }
		        else
		        {
		            char *w = s - 1;
		            *w = '\0';
		        }
		        *last = s;
		        return tok;
	        }
	    }
	    while (sc != 0);
    }
}
