extern int debug;
extern int mode;
extern int verbose;
extern int port;
extern int dbon;
extern int allow_kill;
extern struct passwd *userinfo;
extern struct config_struct *config;

extern int print_debug(int, char *, ...);
extern void get_userinfo(void);
extern void reject(int);

extern int net_connect(const char *, const int);
extern char * net_read(int);
extern int net_send(int, char *);
extern int net_nsend(int, char *, int);
extern char *getip(const char *);
extern void do_thru_connect(int, int);

extern int test_proxy(const char *, const int, const char *, const int);
extern int test_sock(const char *, const int);
extern int make_socks5_request(const char *, const char *, int, char *, int *, int);
extern int make_socks4_request(const char *, const char *, int, char *, int *, int);
extern int initial_request(int, char *, int *);

extern int make_connect_request(char *, const char *, int,  int);
extern int parse_config(int, char **);
extern int lock_config(char *);
extern void release_config(int);
extern void read_config(int);
extern char * read_file(int);
extern void parse_line(char *);
extern void cleanup(void);

extern void do_signal(int);
extern void catch_child(int);
extern void background(void);
extern void do_child(void);
extern void sleep_check(int, int);
extern void check_parent(int, int);
extern void start_listener(int);
extern int start_daemon_mode(void);
extern int start_logs(void);
extern int setup_port(void);
extern int setup_sighandler(void);
extern void init_workerinfo(void);
extern void kill_workers(void);
extern void free_workers(int);

extern void start_tests(const char *);
extern void send_command(const char *, int, int);

extern int spin_lock(const char *);
extern void release_lock(int);

